[PATCH] perf test: probe_vfs_getname add do_getname() probing fallback
From: Thomas Richter
Date: Thu Apr 16 2026 - 08:55:55 EST
The following tests are skipped for some time now on platforms
s390 and x86_64:
# perf test vfs_getname
138: Add vfs_getname probe to get syscall args filenames : Skip
140: Use vfs_getname probe to get syscall args filenames : Skip
154: Check open filename arg using perf trace + vfs_getname : Skip
#
This is caused by a change in kernel code of function
getname_flags(), see
commit 9fa3ec84587c ("allow incomplete imports of filenames")
This commit changed the function getname_flags() implementation.
Now the perf probe 'vfs_getname parameter=xxx' does not match any
more. Extend the test logic to fall back to probing do_getname().
This reflects the updated kernel code.
Output after:
# perf test vfs_getname
138: Add vfs_getname probe to get syscall args filenames : Ok
140: Use vfs_getname probe to get syscall args filenames : Ok
154: Check open filename arg using perf trace + vfs_getname : Ok
#
Signed-off-by: Thomas Richter <tmricht@xxxxxxxxxxxxx>
Reviewed-by: Sumanth Korikkar <sumanthk@xxxxxxxxxxxxx>
---
tools/perf/tests/shell/lib/probe_vfs_getname.sh | 16 +++++++++++++++-
1 file changed, 15 insertions(+), 1 deletion(-)
diff --git a/tools/perf/tests/shell/lib/probe_vfs_getname.sh b/tools/perf/tests/shell/lib/probe_vfs_getname.sh
index 88cd0e26d5f6..9156a79212b9 100644
--- a/tools/perf/tests/shell/lib/probe_vfs_getname.sh
+++ b/tools/perf/tests/shell/lib/probe_vfs_getname.sh
@@ -12,6 +12,8 @@ cleanup_probe_vfs_getname() {
add_probe_vfs_getname() {
add_probe_verbose=$1
+ do_getname=0
+
if [ $had_vfs_getname -eq 1 ] ; then
result_initname_re="[[:space:]]+([[:digit:]]+)[[:space:]]+initname.*"
line=$(perf probe -L getname_flags 2>&1 | grep -E "$result_initname_re" | sed -r "s/$result_initname_re/\1/")
@@ -28,12 +30,24 @@ add_probe_vfs_getname() {
line=$(perf probe -L getname_flags 2>&1 | grep -E "$result_aname_re" | sed -r "s/$result_aname_re/\1/")
fi
+ if [ -z "$line" ] ; then
+ do_getname=1
+ result_iname_re="[[:space:]]+([[:digit:]]+)[[:space:]]+initname\(result\);"
+ line=$(perf probe -L do_getname 2>&1 | grep -E "$result_iname_re" | sed -r "s/$result_iname_re/\1/")
+ fi
+
if [ -z "$line" ] ; then
echo "Could not find probeable line"
return 2
fi
- perf probe -q "vfs_getname=getname_flags:${line} pathname=result->name:string" || \
+ if [ "$do_getname" -eq 1 ]
+ then
+ param="vfs_getname=do_getname:${line} pathname=result->iname:string"
+ perf probe -q "$param" || perf probe $add_probe_verbose "$param" || return 1
+ return 0
+ fi
+ perf probe -q "vfs_getname=getname_flags:${line} pathname=result->name:string" || \
perf probe $add_probe_verbose "vfs_getname=getname_flags:${line} pathname=filename:ustring" || return 1
fi
}
--
2.53.0